# coding=utf-8
from naoqi import ALProxy


class NaoMotion:
    def __init__(self, ip, port):
        self.motion = ALProxy("ALMotion", ip, port)
        self.motion.wakeUp()

    # 设置第一棒的动作
    def set_first_arms(self):
        self.motion.setAngles("LHand", 0, 0.5)
        names = list()
        times = list()
        keys = list()

        names.append("LElbowRoll")
        times.append([1.8])
        keys.append([-0.0183661])

        names.append("LElbowYaw")
        times.append([1.8])
        keys.append([-1.49262])

        names.append("LHand")
        times.append([1.8])
        keys.append([0.058])

        names.append("LShoulderPitch")
        times.append([1.8])
        keys.append([-0.0276539])

        names.append("LShoulderRoll")
        times.append([1.8])
        keys.append([0.030638])

        names.append("LWristYaw")
        times.append([1.8])
        keys.append([1.67509])

        names.append("RElbowRoll")
        times.append([1.8])
        keys.append([0.142704])

        names.append("RElbowYaw")
        times.append([1.8])
        keys.append([0.720938])

        names.append("RHand")
        times.append([1.8])
        keys.append([0.7464])

        names.append("RShoulderPitch")
        times.append([1.8])
        keys.append([1.30087])

        names.append("RShoulderRoll")
        times.append([1.8])
        keys.append([-0.144238])

        names.append("RWristYaw")
        times.append([1.8])
        keys.append([1.07376])

        try:
            self.motion.angleInterpolation(names, keys, times, True)
        except BaseException as err:
            print(err)

    # 设置第二棒的动作
    def set_second_arms(self):
        self.motion.setAngles("LHand", 0, 0.5)
        names = list()
        times = list()
        keys = list()

        names.append("LElbowRoll")
        times.append([1.68])
        keys.append([-1.51095])

        names.append("LElbowYaw")
        times.append([1.68])
        keys.append([-1.61688])

        names.append("LHand")
        times.append([1.68])
        keys.append([0.6512])

        names.append("LShoulderPitch")
        times.append([1.68])
        keys.append([1.18421])

        names.append("LShoulderRoll")
        times.append([1.68])
        keys.append([-0.0859461])

        names.append("LWristYaw")
        times.append([1.68])
        keys.append([-1.50336])

        names.append("RElbowRoll")
        times.append([1.68])
        keys.append([0.312978])

        names.append("RElbowYaw")
        times.append([1.68])
        keys.append([0.83292])

        names.append("RHand")
        times.append([1.68])
        keys.append([0.7536])

        names.append("RShoulderPitch")
        times.append([1.68])
        keys.append([1.33155])

        names.append("RShoulderRoll")
        times.append([1.68])
        keys.append([0.0858622])

        names.append("RWristYaw")
        times.append([1.68])
        keys.append([1.07836])

        try:
            # uncomment the following line and modify the IP if you use this script outside Choregraphe.
            # motion = ALProxy("ALMotion", IP, 9559)
            motion = ALProxy("ALMotion")
            motion.angleInterpolation(names, keys, times, True)
        except BaseException, err:
            print err

        try:
            self.motion.angleInterpolation(names, keys, times, True)
        except BaseException as err:
            print(err)

    # 可以添加其他与运动相关的方法...


if __name__ == '__main__':
    IP = "192.168.30.11"
    PORT = 9559

    nao_motion = NaoMotion(IP, PORT)
    nao_motion.set_first_arms()
    nao_motion.set_second_arms()
